﻿#include "hmg.ch"

//Edit_State() nParameter
#define EST_SELSTART    1
#define EST_SELEND      2
#define EST_INSERT      3
#define EST_CARETWIDTH  4
#define EST_CARETHEIGHT 5
#define EST_COUNT       5
#define EST_SELARR      101
#define EST_CARETARR    102
#define EST_ALLARR      103

MEMVAR _HMG_SYSDATA


FUNCTION Main()

  SET FONT TO "MS Shell Dlg", 8

  DEFINE WINDOW Demo;
    MAIN;
    ROW    100;
    COL    100;
    WIDTH  490 + GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/) * 2;
    HEIGHT 350 + GetSystemMetrics(4 /*SM_CYCAPTION*/) + GetSystemMetrics(8 /*SM_CYFIXEDFRAME*/) * 2;
    TITLE  "EditBox/TextBox - improvement";
    NOSIZE;
    NOMAXIMIZE;
    NOMINIMIZE;
    ON RELEASE Edit_Caret()

    DEFINE LABEL EditLabel
      ROW    10
      COL    10
      WIDTH  470
      HEIGHT 13
      VALUE  "EditBox:"
    END LABEL

    DEFINE EDITBOX Edit1
      ROW          25
      COL          10
      WIDTH        470
      HEIGHT       210
      FONTNAME     "Courier new"
      FONTSIZE     9
      VALUE        "EditBox and TextBox keys:" + CRLF + ;
                   "TAB             - go to next control" + CRLF + ;
                   "Shift+TAB       - go to previous control" + CRLF + ;
                   "INS             - switch Insert/Overtype mode" + CRLF + ;
                   "Ctrl+A          - select all text" + CRLF + ;
                   "Ctrl+Num+       - increase font size" + CRLF + ;
                   "Ctrl+Num-       - decrease font size" + CRLF + ;
                   "Ctrl+Shift+Num+ - increase caret width or height" + CRLF + ;
                   "Ctrl+Shift+Num- - decrease caret width or height" + CRLF + ;
                   "Ctrl+0          - lower case in selection" + CRLF + ;
                   "Ctrl+9          - upper case in selection" + CRLF
      ON GOTFOCUS  (StatusSetName("EditBox"), Edit_Sel("Demo", "Edit1", Edit_State("Demo", "Edit1", EST_SELARR)), Edit_Caret("Demo", "Edit1"))
      ON LOSTFOCUS (Edit_State("Demo", "Edit1", EST_SELARR, Edit_Sel("Demo", "Edit1")), Edit_Caret())
      DISABLEDBACKCOLOR {208, 208, 208}
    END EDITBOX

    DEFINE LABEL TextLabel
      ROW    245
      COL    10
      WIDTH  470
      HEIGHT 13
      VALUE  "TextBox:"
    END LABEL

    DEFINE TEXTBOX Edit2
      ROW          260
      COL          10
      WIDTH        470
      HEIGHT       23
      FONTNAME     "Courier new"
      FONTSIZE     9
      VALUE        HB_CWD()
      ON GOTFOCUS  (StatusSetName("TextBox"), Edit_Sel("Demo", "Edit2", Edit_State("Demo", "Edit2", EST_SELARR)), Edit_Caret("Demo", "Edit2"))
      ON LOSTFOCUS (Edit_State("Demo", "Edit2", EST_SELARR, Edit_Sel("Demo", "Edit2")), Edit_Caret())
      DISABLEDBACKCOLOR {208, 208, 208}
    END TEXTBOX

    DEFINE BUTTON ReadOnly
      ROW          293
      COL          270
      WIDTH        100
      HEIGHT       25
      CAPTION      "Switch &ReadOnly"
      ON GOTFOCUS  StatusSetName("Button")
      ON LOSTFOCUS SendMessage(Demo.ReadOnly.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
      ACTION       ((Demo.Edit1.READONLY := ! Demo.Edit1.READONLY), (Demo.Edit2.READONLY := ! Demo.Edit2.READONLY))
    END BUTTON

    DEFINE BUTTON Exit
      ROW          293
      COL          380
      WIDTH        100
      HEIGHT       25
      CAPTION      "E&xit"
      ON GOTFOCUS  StatusSetName("Button")
      ON LOSTFOCUS SendMessage(Demo.Exit.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
      ACTION       Demo.RELEASE
    END BUTTON

    DEFINE STATUSBAR
      STATUSITEM ""
      STATUSITEM "" WIDTH 80
      STATUSITEM "" WIDTH 80
      STATUSITEM "" WIDTH 100
      STATUSITEM "" WIDTH 80
      STATUSITEM "" WIDTH 70
      STATUSITEM "" WIDTH 40
    END STATUSBAR
  END WINDOW

  Edit_State("Demo", "Edit1", EST_SELARR,   {0, 25})
  Edit_State("Demo", "Edit2", EST_SELARR,   {0, 2})
  Edit_State("Demo", "Edit1", EST_CARETARR, {2, 2})
  Edit_State("Demo", "Edit2", EST_CARETARR, {2, 2})

  InstallEventHandler("MainEventHandler")
  EventProcessAllHookMessage(EventCreate("Edit_Event", Demo.Edit1.HANDLE), .T.)
  EventProcessAllHookMessage(EventCreate("Edit_Event", Demo.Edit2.HANDLE), .T.)

  Demo.CENTER
  Demo.ACTIVATE

RETURN NIL


FUNCTION MainEventHandler(nHWnd, nMsg, nWParam, nLParam)
  LOCAL nHWndNext

  IF nHWnd == Demo.HANDLE
    IF nMsg == 40 /*WM_NEXTDLGCTL*/
      //to avoid select entire text in TEXTBOX control on got focus
      IF LoWord(nLParam) == 0
        nHWndNext := GetNextDlgTabItem(GetActiveWindow(), GetFocus(), (nWParam != 0))

        SetFocus(nHWndNext)

        IF GetControlTypeByIndex(GetControlIndexByHandle(nHWndNext)) == "BUTTON"
          SendMessage(nHWndNext, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
        ENDIF

        RETURN 1
      ENDIF
    ENDIF
  ENDIF

RETURN NIL


FUNCTION Edit_Event()
  LOCAL nHWnd := EventHWND()
  LOCAL nWParam
  LOCAL cForm
  LOCAL cCtl
  LOCAL nFontSize
  LOCAL nSel1, nSel2
  LOCAL nRow1, nRow2, nCol1, nCol2
  LOCAL nX, nY
  LOCAL nCaret
  LOCAL cText
  LOCAL nRetVal

  IF GetFocus() == nHWnd
    nWParam := EventWPARAM()

    GetControlNameByHandle(nHWnd, @cCtl, @cForm)

    SWITCH EventMSG()
      CASE 256 /*WM_KEYDOWN*/
        SWITCH nWParam
          CASE VK_INSERT
            IF (GetKeyState(VK_CONTROL) >= 0) .and. (GetKeyState(VK_SHIFT) >= 0)
              Edit_State(cForm, cCtl, EST_INSERT, ! Edit_State(cForm, cCtl, EST_INSERT))
              Edit_Caret(cForm, cCtl)
            ENDIF
            EXIT

          CASE VK_A
            IF (GetKeyState(VK_CONTROL) < 0) .and. (GetKeyState(VK_SHIFT) >= 0) .and. (GetKeyState(VK_ALT) >= 0)
              HMG_EditControlSetSel(nHWnd, 0, -1)
              nRetVal := 0
            ENDIF
            EXIT

          CASE VK_ADD
            IF (GetKeyState(VK_CONTROL) < 0) .and. (GetKeyState(VK_ALT) >= 0)
              IF GetKeyState(VK_SHIFT) < 0
                IF Edit_State(cForm, cCtl, EST_INSERT)
                  Edit_State(cForm, cCtl, EST_CARETWIDTH, Edit_State(cForm, cCtl, EST_CARETWIDTH) + 1)
                ELSE
                  Edit_State(cForm, cCtl, EST_CARETHEIGHT, Edit_State(cForm, cCtl, EST_CARETHEIGHT) + 1)
                ENDIF
                Edit_Caret(cForm, cCtl)
              ELSE
                nFontSize := GetProperty(cForm, cCtl, "FONTSIZE")
                IF nFontSize < 50
                  SetProperty(cForm, cCtl, "FONTSIZE", nFontSize + 1)
                  Edit_Caret(cForm, cCtl)
                ENDIF
              ENDIF
              RETURN 0
            ENDIF
            EXIT

          CASE VK_SUBTRACT
            IF (GetKeyState(VK_CONTROL) < 0) .and. (GetKeyState(VK_ALT) >= 0)
              IF GetKeyState(VK_SHIFT) < 0
                IF Edit_State(cForm, cCtl, EST_INSERT)
                  Edit_State(cForm, cCtl, EST_CARETWIDTH, Edit_State(cForm, cCtl, EST_CARETWIDTH) - 1)
                ELSE
                  Edit_State(cForm, cCtl, EST_CARETHEIGHT, Edit_State(cForm, cCtl, EST_CARETHEIGHT) - 1)
                ENDIF
                Edit_Caret(cForm, cCtl)
              ELSE
                nFontSize := GetProperty(cForm, cCtl, "FONTSIZE")
                IF nFontSize > 2
                  SetProperty(cForm, cCtl, "FONTSIZE", nFontSize - 1)
                  Edit_Caret(cForm, cCtl)
                ENDIF
              ENDIF
              RETURN 0
            ENDIF
            EXIT

          CASE VK_0
            IF ! GetProperty(cForm, cCtl, "READONLY")
              HMG_EditControlGetSel(nHWnd, @nSel1, @nSel2)
              cText := Edit_GetTextRange(nHWnd, nSel1, nSel2)
              HMG_EditControlReplaceSel(nHWnd, .T., HMG_Lower(cText))
              HMG_EditControlSetSel(nHWnd, nSel1, nSel2)
            ENDIF
            EXIT

          CASE VK_9
            IF ! GetProperty(cForm, cCtl, "READONLY")
              HMG_EditControlGetSel(nHWnd, @nSel1, @nSel2)
              cText := Edit_GetTextRange(nHWnd, nSel1, nSel2)
              HMG_EditControlReplaceSel(nHWnd, .T., HMG_Upper(cText))
              HMG_EditControlSetSel(nHWnd, nSel1, nSel2)
            ENDIF
            EXIT
        ENDSWITCH
        EXIT

      CASE 258 /*WM_CHAR*/
        HMG_EditControlGetSel(nHWnd, @nSel1, @nSel2)
        IF (nWParam >= 32) .and. (! Edit_State(cForm, cCtl, EST_INSERT)) .and. (nSel1 == nSel2) .and. ;
           (nSel1 != (SendMessage(nHWnd, 187 /*EM_LINEINDEX*/, SendMessage(nHWnd, 201 /*EM_LINEFROMCHAR*/, nSel1, 0), 0) + SendMessage(nHWnd, 193 /*EM_LINELENGTH*/, nSel1, 0)))
          HMG_EditControlSetSel(nHWnd, nSel1, nSel1 + 1)
          RETURN NIL
        ENDIF
        EXIT
    ENDSWITCH

    HMG_EditControlGetSel(nHWnd, @nSel1, @nSel2)
    nRow1 := SendMessage(nHWnd, 201 /*EM_LINEFROMCHAR*/, nSel1, 0)
    nRow2 := SendMessage(nHWnd, 201 /*EM_LINEFROMCHAR*/, nSel2, 0)
    nCol1 := nSel1 - SendMessage(nHWnd, 187 /*EM_LINEINDEX*/, nRow1, 0)
    nCol2 := nSel2 - SendMessage(nHWnd, 187 /*EM_LINEINDEX*/, nRow2, 0)

    GetCaretPos(@nX, @nY)
    nCaret := LoWord(SendMessage(nHWnd, 215 /*EM_CHARFROMPOS*/, 0, MAKELONG(nX, nY)))
    cText  := Edit_GetTextRange(nHWnd, nCaret, nCaret + 1)

    Demo.STATUSBAR.Item(2) := HB_NtoS(nRow1 + 1) + "," + HB_NtoS(nCol1 + 1) + If(nSel1 != nSel2, " : " + HB_NtoS(nRow2 + 1) + "," + HB_NtoS(nCol2 + 1), "")
    Demo.STATUSBAR.Item(3) := HB_NtoS(nSel1 + 1) + If(nSel1 != nSel2, " : " + HB_NtoS(nSel2 + 1), "")
    Demo.STATUSBAR.Item(4) := cText + " 0x" + HB_NumtoHex(HB_UCode(cText), 4) + " (" + HB_NtoS(HB_UCode(cText)) + ")"
    Demo.STATUSBAR.Item(5) := "Chars: " + HB_NtoS(SendMessage(nHWnd, 14 /*WM_GETTEXTLENGTH*/, 0, 0))
    Demo.STATUSBAR.Item(6) := "Lines: " + HB_NtoS(SendMessage(nHWnd, 186 /*EM_GETLINECOUNT*/, 0, 0))
    Demo.STATUSBAR.Item(7) := If(Edit_State(cForm, cCtl, EST_INSERT), "Ins", "")
  ENDIF

RETURN nRetVal


       //Edit_Caret([cFormName], [cControlName])
FUNCTION Edit_Caret(cForm, cCtl)
  STATIC nHBitmap := 0
  LOCAL  nHWnd
  LOCAL  nFontW, nFontH
  LOCAL  nCaretW, nCaretH

  DestroyCaret()

  IF (nHBitmap != 0)
    DeleteObject(nHBitmap)
    nHBitmap := 0
  ENDIF

  IF HB_IsString(cForm) .and. HB_IsString(cCtl) 
    nHWnd := GetControlHandle(cCtl, cForm)

    //bug in HMG_GetAverageFontSize(), reported: http://www.hmgforum.com/viewtopic.php?f=20&t=5297
    GetAverageFontSize(nHWnd, @nFontW, @nFontH)

    IF Edit_State(cForm, cCtl, EST_INSERT)
      nCaretW := Edit_State(cForm, cCtl, EST_CARETWIDTH)

      IF (nCaretW < 1) .or. (nCaretW > nFontW)
        IF nCaretW < 1
          nCaretW := 1
        ELSE
          nCaretW := nFontW
        ENDIF
        Edit_State(cForm, cCtl, EST_CARETWIDTH, nCaretW)
      ENDIF

      CreateCaret(nHWnd, 0, nCaretW, nFontH)

    ELSE
      nCaretH := Edit_State(cForm, cCtl, EST_CARETHEIGHT)

      IF (nCaretH < 1) .or. (nCaretH > nFontH)
        IF nCaretH < 1
          nCaretH := 1
        ELSE
          nCaretH := nFontH
        ENDIF
        Edit_State(cForm, cCtl, EST_CARETHEIGHT, nCaretH)
      ENDIF

      nHBitmap := CreateCaretBitmap(nFontW, nFontH, nCaretH)
      CreateCaret(nHWnd, nHBitmap, 0, 0)
    ENDIF

    ShowCaret(nHWnd)
  ENDIF

RETURN NIL


       //Edit_Sel(cForm, cControl, [aSel]) --> previous aSel
FUNCTION Edit_Sel(cForm, cCtl, aSel)
  LOCAL nHWnd
  LOCAL nSelStart1
  LOCAL nSelEnd1
  LOCAL nSelStart2
  LOCAL nSelEnd2

  IF _IsControlDefined(cCtl, cForm)
    nHWnd := GetControlHandle(cCtl, cForm)

    HMG_EditControlGetSel(nHWnd, @nSelStart1, @nSelEnd1)

    IF HB_IsArray(aSel)
      nSelStart2 := 0
      nSelEnd2   := 0

      IF (Len(aSel) > 0) .and. HB_IsNumeric(aSel[1])
        nSelStart2 := aSel[1]
      ENDIF

      IF (Len(aSel) > 1) .and. HB_IsNumeric(aSel[2])
        nSelEnd2 := aSel[2]
      ENDIF

      HMG_EditControlSetSel(nHWnd, nSelStart2, nSelEnd2)
    ENDIF
  ENDIF

RETURN {nSelStart1, nSelEnd1}


       //Edit_State(cFormName, cControlName, nParameter, [xSetState])
       //save edit control parameters (EST_*) and return previous state
FUNCTION Edit_State(cForm, cCtl, nPar, xSet)
  STATIC hSt := {=>}
  LOCAL  xPrev
  LOCAL  aType
  LOCAL  n

  cForm := Upper(cForm)
  cCtl  := Upper(cCtl)

  IF ! HB_hHasKey(hSt, cForm)
    hSt[cForm] := {=>}
  ENDIF

  IF ! HB_hHasKey(hSt[cForm], cCtl)
    hSt[cForm][cCtl] := {0, -1, .T., 1, 1}
  ENDIF

  IF nPar <= EST_COUNT
    xPrev := hSt[cForm][cCtl][nPar]
  ELSE
    SWITCH nPar
      CASE EST_SELARR
        xPrev := {hSt[cForm][cCtl][EST_SELSTART], hSt[cForm][cCtl][EST_SELEND]}
        EXIT

      CASE EST_CARETARR
        xPrev := {hSt[cForm][cCtl][EST_CARETWIDTH], hSt[cForm][cCtl][EST_CARETHEIGHT]}
        EXIT

      CASE EST_ALLARR
        xPrev := Array(EST_COUNT)
        FOR n := 1 TO EST_COUNT
          xPrev[n] := hSt[cForm][cCtl][n]
        NEXT
        EXIT
    ENDSWITCH
  ENDIF

  IF ! HB_IsNIL(xSet)
    SWITCH nPar
      CASE EST_SELSTART
      CASE EST_SELEND
      CASE EST_CARETWIDTH
      CASE EST_CARETHEIGHT
        IF HB_IsNumeric(xSet)
          hSt[cForm][cCtl][nPar] := xSet
        ENDIF
        EXIT

      CASE EST_INSERT
        IF HB_IsLogical(xSet)
          hSt[cForm][cCtl][nPar] := xSet
        ENDIF
        EXIT

      CASE EST_SELARR
        IF HB_IsArray(xSet)
          IF (Len(xSet) >= 1) .and. HB_IsNumeric(xSet[1])
            hSt[cForm][cCtl][EST_SELSTART] := xSet[1]
          ENDIF
          IF (Len(xSet) >= 2) .and. HB_IsNumeric(xSet[2])
            hSt[cForm][cCtl][EST_SELEND] := xSet[2]
          ENDIF
        ENDIF
        EXIT

      CASE EST_CARETARR
        IF HB_IsArray(xSet)
          IF (Len(xSet) >= 1) .and. HB_IsNumeric(xSet[1])
            hSt[cForm][cCtl][EST_CARETWIDTH] := xSet[1]
          ENDIF
          IF (Len(xSet) >= 2) .and. HB_IsNumeric(xSet[2])
            hSt[cForm][cCtl][EST_CARETHEIGHT] := xSet[2]
          ENDIF
        ENDIF
        EXIT

      CASE EST_ALLARR
        IF HB_IsArray(xSet)
          aType := {"N", "N", "L", "N", "N"}
          FOR n := 1 TO EST_COUNT
            IF (Len(xSet) >= n) .and. (ValType(xSet[n] == aType[n]))
              hSt[cForm][cCtl][n] := xSet[n]
            ENDIF
          NEXT
        ENDIF
        EXIT
    ENDSWITCH
  ENDIF

RETURN xPrev


FUNCTION StatusSetName(cName)

  Demo.STATUSBAR.Item(1) := cName
  Demo.STATUSBAR.Item(2) := ""
  Demo.STATUSBAR.Item(3) := ""
  Demo.STATUSBAR.Item(4) := ""
  Demo.STATUSBAR.Item(5) := ""
  Demo.STATUSBAR.Item(6) := ""
  Demo.STATUSBAR.Item(7) := ""

RETURN NIL


#pragma BEGINDUMP

#include "SET_COMPILE_HMG_UNICODE.ch"
#include "HMG_UNICODE.h"

#include <windows.h>
#include "hbapi.h"


        //GetAverageFontSize(nHWnd, @nWidth, @nHeight)
HB_FUNC ( GETAVERAGEFONTSIZE )
{
  HWND       hWnd  = (HWND) HMG_parnl(1);
  HDC        hDC   = GetDC(hWnd);
  HFONT      hFont = SelectObject(hDC, (HFONT) SendMessage(hWnd, WM_GETFONT, 0, 0));
  TEXTMETRIC TextMetric;

  hb_retl((BOOL) GetTextMetrics(hDC, &TextMetric));

  if (HB_ISBYREF(2))
    hb_stornl((LONG) TextMetric.tmAveCharWidth, 2);
  if (HB_ISBYREF(3))
    hb_stornl((LONG) TextMetric.tmHeight, 3);

  SelectObject(hDC, hFont);
  ReleaseDC(hWnd, hDC);
}


        //CreateCaretBitmap(nFontW, nFontH, nCaretH)
HB_FUNC ( CREATECARETBITMAP )
{
  INT     nFontW  = hb_parni(1);
  INT     nFontH  = hb_parni(2);
  INT     nCaretH = hb_parni(3);
  HDC     hDC     = CreateCompatibleDC(NULL);
  HBITMAP hBitmap = CreateBitmap(nFontW, nFontH, 1, 1, 0);
  HBITMAP hBmpOld = SelectObject(hDC, hBitmap);

  SelectObject(hDC, GetStockObject(WHITE_BRUSH));
  SelectObject(hDC, GetStockObject(WHITE_PEN));
  Rectangle(hDC, 0, nFontH - nCaretH, nFontW, nFontH);

  SelectObject(hDC, hBmpOld);
  DeleteDC(hDC);

  HMG_retnl((INT_PTR) hBitmap);
}


       //Edit_GetTextRange(nHWnd, nStart, nEnd)
HB_FUNC (EDIT_GETTEXTRANGE)
{
  HWND   hWnd   = (HWND) HMG_parnl(1);
  INT    nStart = (INT)  hb_parnl(2);
  INT    nEnd   = (INT)  hb_parnl(3);
  INT    nLen   = nEnd - nStart;
  HLOCAL hMem   = (HLOCAL) SendMessage(hWnd, EM_GETHANDLE, 0, 0);
  TCHAR  *pBuf;
  TCHAR  Text[nLen + 1];
  INT    nBufLen;
  INT    n;

  Text[nLen] = 0;

  if (hMem)
    pBuf = (TCHAR *) LocalLock(hMem);
  else
  {
    nBufLen = (INT) SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0) + 1;
    pBuf    = (LPTSTR) hb_xgrab(nBufLen * sizeof(TCHAR));

    SendMessage(hWnd, WM_GETTEXT, nBufLen, (LPARAM) pBuf);
  }

  for (n = 0; n < nLen; ++n)
    Text[n] = pBuf[nStart + n];

  if (hMem)
    LocalUnlock(hMem);
  else
    hb_xfree(pBuf);

  HMG_retc(Text);
}

#pragma ENDDUMP
